<template>
  <div class="fixed-tarif">
    <i
      v-if="price"
      class="icon lock price-locked"
      :class="{'price-unlocked': !isFixedPriceCurrently}"
      @click.stop="toggleFixedPrice"></i>

      <div class="price">
        <div class="price__stage">
          <ObInput
              v-model="localPrice"
              type="money:2"
              :mini="true"
              data-qa="ContainerfixedPriceInputBP"
              @change="updateFixedPrice()"
          />
        </div>
        <div class="price__km" v-if="price.priceKm">
          <span class="price__km-currency">₽/км</span>
          {{ priceFormat(price.priceKm) }}
        </div>
      </div>

  </div>
</template>
<script>

import api from '@/api';
import ObInput from 'common-components/src/obComponents/obInput';
import numberWithSpaces from '@/utils/formatNumber';

export default {
  name: 'ContainerFixedPrice',
  components: {
    ObInput,
  },
  props: {
    isFixedPriceCurrently: {
      type: Boolean,
      default: () => false
    },
    price: {
      type: Object,
      default: () => {}
    },
    directionUuid: {
      type: String,
      default: () => ''
    },
    clusterFromUuid: {
      type: String,
      default: () => ''
    },
    clusterToUuid: {
      type: String,
      default: () => ''
    },
    resourcesGroupUuid: {
      type: String,
      default: () => ''
    },
    serviceUuid: {
      type: String,
      default: () => ''
    },
  },
  data() {
    return {
      localPrice: this.price?.priceStage ?? 0,
    }
  },
  methods: {
    priceFormat(value, divider = 100) {
      return numberWithSpaces(value, divider).replace('.', ',');
    },
    async toggleFixedPrice(){
      if(this.isFixedPriceCurrently || this.localPrice <= 0) {
        await this.updateFixedPrice(true);
      } else {
        await this.updateFixedPrice();
      }
    },
    async updateFixedPrice(del = false) {
        try {
          if( this.localPrice > 0 && !del ) {
            await api.base_prices_clustering.setContainerFixedPrice({
              directionUuid: this.directionUuid,
              clusterFromUuid: this.clusterFromUuid,
              clusterToUuid: this.clusterToUuid,
              resourcesGroupUuid: this.resourcesGroupUuid,
              serviceUuid: this.serviceUuid,
              priceStage: this.localPrice,
              priceKm: this.localPrice,
              distance: 1,
            });
          } else {
            await api.base_prices_clustering.cancelContainerFixedPrice({
              directionUuid: this.directionUuid,
              clusterFromUuid: this.clusterFromUuid,
              clusterToUuid: this.clusterToUuid,
              resourcesGroupUuid: this.resourcesGroupUuid,
              serviceUuid: this.serviceUuid,
            });
          }
          this.$emit('update');
          this.$notification({
            type: 'system_notification_success',
            message: `Сохранено`,
          });

        } catch {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка сохранения',
          });
        }
    }
  }
}
</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.fixed-tarif{
  display: flex;
  align-items: center;
  position: relative;

  .icon.lock{
    font-size: 25px;
    margin-right: 15px;
    cursor: pointer;
    &.price-locked{
      color: $light-raspberry-red;
    }
    &.price-unlocked {
      color: #dedede;
    }
  }

  .price__km-currency{
    font-size: 12px;
    color: $gray-slate;
    flex: none;
  }

  &::v-deep {

    .ob-input-wrap{
      padding-right: 5px;
    }

    .input-group .input{
      text-align: right;
    }

    .ob-input-container .input{
      font-size: 16px;
    }

    &:not(:hover) {
      .ob-input-container .ob-input-wrap{
        background: transparent;
        border-color: transparent;
      }
    }

  }
}
.price{
  text-align: right;
  &__stage{
    font-size: 16px;
    margin-right: -6px;

    &.gray{
      color: $gray-slate;
    }
    .price__km-currency{
      font-size: 12px;
      color: $gray-slate;
    }
  }
  &__km{
    color: $gray-slate;
    font-size: 12px;
  }
  &__km-currency{
    margin-right: 5px;
  }
}


</style>
